/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// GenomeBrowser Project
//
// BrowserService.java
// Since: Apr 20, 2007
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/utgb/client/BrowserService.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.utgb.client;


import java.util.List;

import org.utgenome.gwt.utgb.client.track.bean.SearchResult;

import com.google.gwt.user.client.rpc.RemoteService;

public interface BrowserService extends RemoteService
{
    
    //public String getDataModelParameter(String dataModelQueryJSONData);
    public String countDataModelElementValues(String amoebaQuery);
    
    /**
     * @gwt.typeArgs <java.lang.String>
     */
    //public List listDataModelElementValues(String amoebaQuery, String targetParameter);

    
    public String getHTTPContent(String url);
    
    public String getDatabaseCatalog(String jdbcAddress);
    
    public String getTableData(String jdbcAddress, String tableName);
    
    
    /**
     * @gwt.typeArgs <org.utgenome.gwt.utgb.client.track.bean.TrackBean>
     */
    public List getTrackList(int entriesPerPage, int page);
    
    public int numHitsOfTracks(String prefix);

    /**
     * @gwt.typeArgs <org.utgenome.gwt.utgb.client.track.bean.TrackBean>
     */
    public List getTrackList(String prefix, int entriesPerPage, int page);
    
    public SearchResult keywordSearch(String keyword, int entriesPerPage, int page);
    
    public void saveView(String viewXML);
    public String getCurrentView();
}

