/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// utgb-core Project
//
// UTGBResourceCenter.java
// Since: Oct 2, 2007
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/utgb/client/UTGBResourceCenter.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.utgb.client;

import org.utgenome.gwt.utgb.client.track.TrackGroup;
import org.utgenome.gwt.utgb.client.track.TrackQueue;
import org.utgenome.gwt.utgb.client.track.lib.NavigatorTrack;
import org.utgenome.gwt.utgb.client.track.lib.ToolBoxTrack;
import org.utgenome.gwt.utgb.client.track.lib.center.TrackFinderTrack;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.RootPanel;

/**
 * Central data resource interface
 * 
 * @author leo
 * 
 */
public class UTGBResourceCenter implements EntryPoint
{
    // widgets
    private DockPanel dockPanel = new DockPanel();
    private TrackGroup trackGroup = new TrackGroup("root");
    private TrackQueue trackQueue = new TrackQueue(trackGroup);

    public static String getActionURL(String actionName, String queryString)
    {
        if (GWT.isScript())
        {
            return GWT.getModuleBaseURL() + actionName + ".action?" + queryString;
        }
        else
        {
            return GWT.getModuleBaseURL() + "dispatcher?actionClass=" + "org.utgenome.gwt.utgb.server.app."
                    + actionName + "&" + queryString;
        }
    }

    public void onModuleLoad()
    {

        GenomeBrowser.initServices();

        trackGroup.addTrack(new ToolBoxTrack());
        trackGroup.addTrack(new NavigatorTrack());
        trackGroup.addTrack(new TrackFinderTrack());
        // trackGroup.addTrack(new SequenceRulerTrack());
        // trackGroup.addTrack(new RulerTrack());

        dockPanel.add(trackQueue, DockPanel.CENTER);

        RootPanel.get().add(dockPanel);

    }

}
