/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// GenomeBrowser Project
//
// Query.java
// Since: Jun 29, 2007
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/utgb/client/db/Query.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.utgb.client.db;

import java.util.ArrayList;
import java.util.HashMap;
   
 
/** 
 * 
 * path: imaginary file path managed by the multimodal DB server
 * <h2>Query:</h2>
 * <pre>
 * Query:
 * { 
 *   "path" : "/home/leo/scmd.db",
 *   "select" : ["orf", "standard_name", "alias"],
 *   "condition" : [["orf", "=", "YOR202W"]],
 *   "page" : 1,
 *   "page_size" : 100,
 * }
 * </pre>
 * 
 * <h2>Returned Result</h2>
 * <pre>
 * {
 *   "schema":["orf", "standard_name", "alias"],
 *   "result":[
 *     ["YOR202w", "HIS3", "HIS10"],
 *     ["YAL002w", "VPS8", ["FUN15","VPT8"]],
 *     ["YAL004w", null, null]
 *   ]
 * }
 * </pre>
 * @author leo 
 *
 */ 
public class Query {
	
	// query target
	private String dbPath;
	private ArrayList _selectionList = new ArrayList();
	private ArrayList _conditionList = new ArrayList();

	// pagination
	private int page = 1;
	private int page_size = 0;	// when page_size = 0, select all data
	
	/**
	 * paramter name to condition
	 */
	private HashMap conditionMap = new HashMap();
	
	public Query()
	{
		
	}
	
	public Query(String jsonData)
	{
		parse(jsonData);
	}
	
	public void parse(String jsonData)
	{
		
	}
	
	public String toJSON()
	{
		// TODO implementation
		return null;
	}
	
	
}




