/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// GenomeBrowser Project
//
// OldUTGBViewer.java
// Since: 2007/06/21
//
// $URL$ 
// $Author$
//--------------------------------------
package org.utgenome.gwt.utgb.client.track.lib.old;

import org.utgenome.gwt.utgb.client.track.TrackGroup;
import org.utgenome.gwt.utgb.client.track.TrackQueue;
import org.utgenome.gwt.web.client.tab.TabEntry;

import com.google.gwt.user.client.ui.DockPanel;

public class OldUTGBViewer extends TabEntry {

	public static TabEntryFactory factory()
    {
        return new TabEntryFactory("UTGB Medaka Genome Browser", "Old UTGB Genome Browser") {
            public TabEntry createInstance()
            {
                return new OldUTGBViewer();
            }};
    }

    private final DockPanel _panel = new DockPanel();
    private final TrackGroup _globalTrackGroup = new TrackGroup("Old UTGB Viewer");
    private final TrackQueue _queue = new TrackQueue(_globalTrackGroup);
    
    public OldUTGBViewer()
    {
    	final OldUTGBTrackGroup trackGroup = new OldUTGBTrackGroup();
    	_globalTrackGroup.addTrackGroup(trackGroup);

    	trackGroup.defaultSetUp();
    	
        _panel.add(_queue, DockPanel.CENTER);
        
        initWidget(_panel);
    }
    
}




