/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// GenomeBrowser Project
//
// EditableLabel.java
// Since: Jun 18, 2007
//
// $URL$ 
// $Author$
//--------------------------------------
package org.utgenome.gwt.utgb.client.ui;

import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.FocusListener;
import com.google.gwt.user.client.ui.SourcesChangeEvents;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;


/**
 * This class is used to implement {@link EditableTable}.
 * @author leo
 *
 */
public class EditableLabel extends TextBox implements SourcesChangeEvents 
{
    private final CellReference _cellReference; 
    
    public EditableLabel(CellReference cellReference, String text)
    {
        _cellReference = cellReference;
        setText(text);
        
        CSS.set(this, CSS.CSS_BORDER, "0");
        CSS.backgroundColor(this, "#9999FF");
        setSize("100%", "100%");

        
        addClickListener(new ClickListener(){
			public void onClick(Widget sender) {
				setSelectionRange(0, getText().length());
				//CSS.backgroundColor(_textBox, "#9999FF");
				//CSS.bold(_textBox);
			}
        });
        addFocusListener(new FocusListener(){
			public void onFocus(Widget sender) {
				//CSS.backgroundColor(_textBox, "#9999FF");
			}

			public void onLostFocus(Widget sender) {
				//CSS.backgroundColor(_textBox, "");
				//CSS.normal(_textBox);
			}
        });
        
    }

    public CellReference getCellReference()
    {
    	return _cellReference;
    }
    
    
}




