/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// UTGB Common Project
//
// AmoebaQuery.java
// Since: Apr 20, 2007
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/web/client/db/amoeba/AmoebaQuery.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.web.client.db.amoeba;


import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import com.google.gwt.json.client.JSONObject;




/**
 * An example of the amoeba query
 *  q1: (species = "human", genome, chromosome, scaffold, track) 
 * 
 * @author leo
 *
 */
public class AmoebaQuery 
{
	public transient static Condition ANY = new Condition(); 
	
	/**
	 * @gwt.typeArgs <java.lang.String,org.utgenome.gwt.web.client.db.amoeba.Condition> 
	 */
	private Map target = new HashMap();

	public AmoebaQuery()
	{}
	
	public void add(String name)
	{
		target.put(name, ANY);
	}
	public void addWithEqualityCondition(String name, String value)
	{
		target.put(name, new Condition(Condition.EQUAL, value));
	}
	
	public Map getTarget()
	{
		return target;
	}
	
	public Condition getCondition(String name)
	{
		return (Condition) target.get(name);
	}
	
	public Set targetSet()
	{
		return target.keySet();
	}
	
	public String toJSON()
	{
		JSONObject json = new JSONObject();
		for(Iterator it = target.keySet().iterator(); it.hasNext(); )
		{
			String param = (String) it.next();
			json.put(param, getCondition(param).toJSONObject());
		}
		return json.toString();
	}
	
}





