/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// UTGB Common Project
//
// Condition.java
// Since: Apr 20, 2007
//
// $Date: 2007-12-27 14:27:01 +0900 $
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/web/client/db/amoeba/Condition.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.web.client.db.amoeba;

import com.google.gwt.json.client.JSONNumber;
import com.google.gwt.json.client.JSONObject;
import com.google.gwt.json.client.JSONString;
import com.google.gwt.json.client.JSONValue;


public class Condition 
{
	transient public final static int ANY = 0;
	transient public final static int EQUAL = 1;
	transient public final static int LESS_THAN = 2;
	transient public final static int LESS_THAN_OR_EQUAL = 3;
	transient public final static int GREATER_THAN = 4;
	transient public final static int GREATER_THAN_OR_EQUAL = 5;
	transient public final static int NOT = 6;

	private int type = ANY;
	private String target = null;
	
	public Condition() 
	{}
	
	public Condition(int type, String comparisonTarget)
	{
		this.type = type;
		this.target = comparisonTarget; 
	}

	
	public int getType() { return type; }
	public String getTarget() { return target; }
	
	public void setTarget(String comparisonTarget) {
		this.target = comparisonTarget;
	}
	public void setType(int type) {
		this.type = type;
	}

	public String toJSON()
	{
		return "{\"type\":" + type + ", \"target\":\"" + target + "\"" + "}"; 
	}

	public JSONValue toJSONObject() {
		JSONObject json = new JSONObject();
		json.put("type", new JSONNumber(type));
		if(target != null)
			json.put("target", new JSONString(target));
		return json;
	}
	
	public boolean isAny()
	{
		return type == ANY;
	}
}




