/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// UTGB Common Project
//
// PasswordType.java
// Since: 2007/04/13
//
// $Date: 2007-12-27 14:27:01 +0900 $
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/web/client/db/datatype/PasswordType.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.web.client.db.datatype;

import com.google.gwt.json.client.JSONString;
import com.google.gwt.json.client.JSONValue;
import com.google.gwt.user.client.ui.ChangeListener;
import com.google.gwt.user.client.ui.KeyboardListener;
import com.google.gwt.user.client.ui.PasswordTextBox;

public class PasswordType extends DataTypeBase
{

	
	public PasswordType(String name) {
		super(name);
	}


	public InputForm getInputForm() {
		return new PasswordTypeForm();
	}

	
	public class PasswordTypeForm extends InputForm
	{
		PasswordTextBox form = new PasswordTextBox();

		/**
		 * @param form
		 */
		public PasswordTypeForm() {
			initWidget(form);
		}

		public JSONValue getJSONValue() {
			return new JSONString(getUserInput());
		}

		public String getUserInput() {
			return form.getText();
		}

		public void setValue(String value) {
			form.setText(value);
		}

		public void setStyleName(String styleName) {
			form.setStyleName(styleName);
		}

		public void addKeyboardListener(KeyboardListener listener) {
			form.addKeyboardListener(listener);
		}
		
		public void addChangeListener(ChangeListener listener) {
			form.addChangeListener(listener);
		}
		
	}
	
	public String getTypeName() {
		return "password";
	}

}




