/*--------------------------------------------------------------------------
 *  Copyright 2007 utgenome.org
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *--------------------------------------------------------------------------*/
//--------------------------------------
// UTGB Common Project
//
// JSONUtil.java
// Since: Jun 15, 2007
//
// $URL: http://svn.utgenome.org/utgb/trunk/utgb/utgb-core/src/main/java/org/utgenome/gwt/web/client/util/JSONUtil.java $ 
// $Author: leo $
//--------------------------------------
package org.utgenome.gwt.web.client.util;

import com.google.gwt.json.client.JSONString;
import com.google.gwt.json.client.JSONValue;

/**
 * A utility for supporting JSONValue manipulation
 * @author leo
 *
 */
public class JSONUtil {

	/**
	 * Get a string value (without double quotation) of JSONString, or other JSON types. 
	 * 
	 * @param value
	 * @return
	 */
	public static String toStringValue(JSONValue value)
	{
		if(value == null)
			return "";
		
		JSONString str = value.isString();
		if(str != null)
			return str.stringValue();
		else
			return value.toString();
	}
	
	
	
	
}




