lexer grammar FASTA;
options {
  language=Java;

}
@members {
private boolean _withinDescription = false;
}
@header {
//--------------------------------------
// UTGB Common Project
//
// FASTALexer.java
// Since: June 6, 2007
//
//--------------------------------------
package org.utgenome.format.fasta;
}

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\utgb\utgb-core\src\main\java\org\utgenome\format\fasta\FASTA.g" 58
SingleLineComment: ';' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;} ;

// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\utgb\utgb-core\src\main\java\org\utgenome\format\fasta\FASTA.g" 60
NewLine: ('\r')? '\n';
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\utgb\utgb-core\src\main\java\org\utgenome\format\fasta\FASTA.g" 61
WhiteSpace: (' ' | '\r' | '\t' | '\u000C' | '\n') 
{
	$channel=HIDDEN;
} ;
 
/*
AminoAcidChar rule completly covers NucleicAcidChar, and to distinguish them is 
difficult just by seeing FASTA input file.

fragment NucleicAcidChar
: 'A' | 'C' | 'G' | 'T' | 'U' 
| 'R' | 'Y' | 'K' | 'M' | 'S' 
| 'W' | 'B' | 'D' | 'H' | 'V' 
| 'N' | '-'
;
*/
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\utgb\utgb-core\src\main\java\org\utgenome\format\fasta\FASTA.g" 77
fragment AminoAcidChar
: 'A' | 'B' | 'C' | 'D' | 'E' 
| 'F' | 'G' | 'H' | 'I' | 'K' 
| 'L' | 'M' | 'N' | 'P' | 'Q' 
| 'R' | 'S' | 'T' | 'U' | 'V' 
| 'W' | 'Y' | 'Z' | 'X' | '*' 
| '-'
;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\utgb\utgb-core\src\main\java\org\utgenome\format\fasta\FASTA.g" 85
fragment AminoAcid: AminoAcidChar+;
// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\utgb\utgb-core\src\main\java\org\utgenome\format\fasta\FASTA.g" 86
SequenceLine
: a=AminoAcid NewLine? { setText(getText().trim()); }  
;


// $ANTLR src "F:\cygwin\home\leo\work\eclipse\workspace\utgb\utgb-core\src\main\java\org\utgenome\format\fasta\FASTA.g" 91
Description: '>' ~('\n'|'\r')* NewLine
	{ setText(getText().trim().substring(1)); } 	// trim '>' and NewLine
;

//-------------------
// parser rules
//-------------------

